﻿package
{
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;

	import flash.geom.Point;
	import flash.geom.Rectangle;

	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.utils.getDefinitionByName;
	
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	
	public class Preloader extends MovieClip
	{
		public var screenbmp:Bitmap;
		public var init_delay:int;
		
		public function Preloader():void
		{
			stop();
			
			var screenbmpdata:BitmapData=new BitmapData(320, 240, false, 0x00000000);
			screenbmp=new Bitmap(screenbmpdata);
			screenbmp.scaleX=2;
			screenbmp.scaleY=2;
			screenbmp.smoothing=false;
			addChild(screenbmp);

			init_delay=0;

			stage.frameRate=60;
			addEventListener(Event.ENTER_FRAME, ProgressStep);
		}
		
		public function ProgressStep(e:Event):void
		{
			if(framesLoaded==totalFrames)
			{
				removeEventListener(Event.ENTER_FRAME, ProgressStep);
				nextFrame();
				InitApplication();
			}
			
			init_delay++;
			if(init_delay<5) // suppress loading screen when swf is cached
				return;
			var fraction:Number=(root.loaderInfo.bytesLoaded/root.loaderInfo.bytesTotal);

			screenbmp.bitmapData.fillRect(new Rectangle(0, 0, 320, 240), 0x000000);

			screenbmp.bitmapData.fillRect(new Rectangle(10, 120-10, 300, 20), 0xFFFFFF);
			screenbmp.bitmapData.fillRect(new Rectangle(10+fraction*300, 120-9, (1-fraction)*300, 18), 0x000000);
		}
		
		public function InitApplication():void
		{
			var GameClass:Class=Class(getDefinitionByName("Main"));
			if(GameClass)
			{
				var game:Object=new GameClass();
				removeChild(screenbmp);
				addChild(game as DisplayObject);
			}
		}
	}
};
