package
{
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;

	public class SoundAssets
	{

		public var sound_array:Array;
		public var channel_array:Array;
		public var mastervol:Number;

		public function SoundAssets():void
		{
			sound_array=new Array(0);
			channel_array=new Array(0);

			mastervol=1.0;
		}

		public function play(id:int, loop:Boolean=false, volume:Number=1.0):void
		{
			channel_array[id].stop();
			if(volume*mastervol==1.0)
				channel_array[id]=sound_array[id].play(0, loop?100000:0, null);
			else
			{
				var st:SoundTransform=new SoundTransform(volume*mastervol, 0);
				channel_array[id]=sound_array[id].play(0, loop?100000:0, st);
			}
		}

		public function stop(id:int):void
		{
			channel_array[id].stop();
		}

		public function setVolume(id:int, volume:Number):void
		{
			channel_array[id].soundTransform=new SoundTransform(volume*mastervol, 0);
		}

		public function masterVolume(volume:Number):void
		{
			mastervol=volume;
		}
	}
}
